unit icqz;

interface

uses windows;

const
  MyDLL           = 'ICQMAPI.dll';  // the ICP external dll
  STATE_ONLINE    = 0;              // the ICQ connection STatus
  STATE_CHAT      = 1;
  STATE_AWAY      = 2;
  STATE_NA        = 3;
  STATE_OCCUPIED  = 4;
  STATE_DND       = 5;
  STATE_INVISIBLE = 6;
  STATE_OFFLINE   = 7;

//  This data structure describes the firewall data the ICQ Client was configured with by the current owner
type FirewallDataP = ^FirewallData;
     FirewallData  = record
       Enabled        : byte; // m_bEnabled - 1 value indicates fire wall is used
       padding1  : array[0..2] OF byte;
       SocksEnabled   : byte; // m_bSocksEnabled - 1 value indicated Socks is used
       padding2  : array[0..2] OF byte;
       Version        : WORD; // m_sSocksVersion - the Socks version (currently 4 or 5)
       padding3  : array[0..1] OF byte;
       Host           : array[0..511] of char; // m_szSocksHost - the name of the Socks host
       Port           : dword; // m_iSocksPort - the name of the Socks Port
       Authentication : byte; //1 value indicates User and Password authentication is used.
end;

//This data structure contains the user information held by ICQ Client.
type
     ICQUserDataPP = ^^ICQUserData;
     ICQUserDataP  = ^ICQUserData;
     USERLIST      = array[0..99] of ICQUserDataP;
     ICQUserData   = record
          UIN       : dword;                   // ICQ unique ID
          Window    : HWND;                    // window HANDLE
          IP        : dword;                   // users IP
          Nickname  : array[0..19] of char;    // nickname
          FirstName : array[0..19] of char;    // firstname
          LastName  : array[0..19] of char;    // lastname
          Email     : array[0..99] of char;    // email
          City      : array[0..99] of char;    // city
          State     : array[0..99] of char;    // state
          Country   : dword;                   // country
          CName     : array[0..99] of char;    // countryname
          HomePage  : array[0..99] of char;    // url homepaga
          Age       : dword;                   // age
          Phone     : array[0..19] of char;    // phonenumber
          Gender    : byte;                    // gender
          padding1  : array[0..2] OF byte;
          HomeZip   : dword;                   // zip hometown
          // Version 1.0001
          StateFlags: dword;                   // connection status
end;

/// set the license key the activate icq DLL
/// Company: MuteFantasies
/// Password: mutefantasies
/// Registration Code: 19FE59A354487CE1

////////////// ported functions from ICQAPI.DLL ////////////////////////
function ICQAPICall_SetLicenseKey   conv arg_stdcall(pszName,pszPassword,pszLicense:pointer):boolean;external MyDLL name 'ICQAPICall_SetLicenseKey';
function ICQAPICall_GetDockingState conv arg_stdcall(var iDockingState:dword):boolean;external MyDLL name 'ICQAPICall_GetDockingState';
function ICQAPICall_GetVersion      conv arg_stdcall(var iVersion:dword):boolean;external MyDLL name 'ICQAPICall_GetVersion';
function ICQAPICall_GetFirewallSettings conv arg_stdcall(BSICQAPI_FireWallData:pointer):boolean;external MyDLL name 'ICQAPICall_GetFirewallSettings';
function ICQAPICall_GetFullUserData conv arg_stdcall(BSICQAPI_User:pointer;iVersion:Dword):boolean;external MyDLL name 'ICQAPICall_GetFullUserData';
function ICQAPICall_GetWindowHandle conv arg_stdcall(var HWND:dword):boolean;external MyDLL name 'ICQAPICall_GetWindowHandle';
function ICQAPICall_SetOwnerState conv arg_stdcall(iState:dword):boolean;external MyDLL name 'ICQAPICall_SetOwnerState';
function ICQAPICall_GetFullOwnerData conv arg_stdcall(var BSICQAPI_User:pointer;iVersion:Dword):boolean;external MyDLL name 'ICQAPICall_GetFullOwnerData';
function ICQAPICall_GetOnlineListDetails conv arg_stdcall(var iCount:dword;BSICQAPI_User:Pointer):boolean;external MyDLL name 'ICQAPICall_GetOnlineListDetails';
function ICQAPICall_SendMessage conv arg_stdcall(UIN:dword;pszMessage:pCHAR):boolean;external MyDLL name 'ICQAPICall_SendMessage';
procedure ICQAPIUtil_FreeUser conv arg_stdcall(var BSICQAPI_User:pointer);external MyDLL name 'ICQAPIUtil_FreeUser';

////////////// my own export functions ////////////////////////
function SetICQLicense:boolean;
function GetICQAPIVersion:boolean;
function FillICQUserIPList:boolean;
function PrintICQownerdetails:boolean;
procedure PrintICQIPList;

////////// variables we need
var ICQversion    : dword;                 // the version number of the ICQ api , hi : major, lo minor version
    ICQUserIPList : array[0..99] of dword; // array of 100 possible ICQ client user IP's
    NrOfICQClient : dword;                 // the number of connected ICQusers to your ICQAPI
    ICQActivated  : boolean;               // is ICQ started?


implementation

uses strings,   // stringfunctions strcopy,...
     winsock;   // for a sockaddr struct for dotted IP notation

var ICQUserNames : array[0..99] of string;



function SetICQLicense:boolean;
var N        : ^char;   // Company developper NAME
    P        : ^char;   // Company developper PASSWORD
    L        : ^char;   // Company developper LICENSE key
begin
     getmem(N,length('MuteFantasies'));         // license developpername
     StrCopy(N,'MuteFantasies');
     getmem(P,length('mutefantasies'));         // license password
     StrCopy(P,'mutefantasies');
     getmem(L,length('19FE59A354487CE1'));      // licens key number
     StrCopy(L,'19FE59A354487CE1');             // set our licens with given
     SetICQLicense:=ICQAPICall_SetLicenseKey(N,P,L); // send result back;
end;

function GetICQAPIVersion:boolean;
begin
    GetICQAPIVersion:=ICQAPICall_GetVersion(ICQversion);
end;

function FillICQUserIPList:boolean;
var list     : ^^USERLIST;
    x        : byte;
    data     : ICQUserDataP;
    res,res1 : boolean;
    temp     : dword;
begin
     ///// get all the memory we need
     new(list);
     new(list^);
     for x:=0 to 99 do getmem(list^^[x],sizeof(ICQUserData));
     ///// get ICQuserlist from the ICQAPI       ICQSTATE MAY NOT BE OFFLINE
     res := ICQAPICall_GetOnlineListDetails(NrOfICQClient,list);
     if res = true then begin
        if NrOfICQClient <> 0 then begin
             getmem(data,sizeof(ICQUserData));
             for x := 0 to NrOfICQClient-1 do begin
                 temp := list^^[x]^.UIN;
                 data^.UIN:=temp;  // writeln(temp);
                 res1 := ICQAPICall_GetFullUserData(data,ICQversion);
                 if res1 = true then begin
                      temp := data^.IP;
                      ICQUserIPList[x]:= temp; //writeln(temp);
                      ICQUserNames[x]:=strpas(data^.Nickname); // writeln(ICQUserNames[x]);
                 end else writeln('ICQAPICall_GetFullUserData failed!');
                 ICQAPIUtil_FreeUser(data);
             end;
             freemem(data,sizeof(ICQUserData));

        end;
     end else writeln('ICQAPICall_GetOnlineListDetails failed!');
     ///// dispose all the allocated memory
     //for x:=0 to 99 do freemem(list^^[x],sizeof(ICQUserData));
     //dispose(list^);
     //dispose(list);

end;

function SetICQState(State:dword):boolean;
begin
     SetICQState:=ICQAPICall_SetOwnerState(State);
end;

function PrintICQownerdetails:boolean;
var data   : ^^ICQUserData;
    res    : boolean;
    socka  : TsockAddr;
    str    : string;
    x      : byte;
begin
getmem(data,sizeof(ICQUserDataP));
getmem(data^,sizeof(ICQUserData));
res := ICQAPICall_GetFullOwnerData(data^,ICQversion);
if res = true then begin
       writeln('     UIN           : ',data^^.UIN);
       writeln('     window        : ',data^^.Window);
       socka.Sin_addr.S_Addr :=data^^.IP;
       str := STRPAS(inet_ntoa(Socka.Sin_Addr));
       writeln('     IP            : ',str);
       write(  '     Nickname      : ');
       for x := 0 to 19 do write(Data^^.Nickname[x]);  writeln('');
       write(  '     Firstname     : ');
       for x := 0 to 19 do write(Data^^.firstname[x]);  writeln('');
       write(  '     LastName      : ');
       for x := 0 to 19 do write(Data^^.lastname[x]);  writeln('');
       write(  '     email         : ');
       for x := 0 to 49 do write(Data^^.email[x]);  writeln('');
       write(  '     city          : ');
       for x := 0 to 49 do write(Data^^.city[x]);  writeln('');
       write(  '     state         : ');
       for x := 0 to 19 do write(Data^^.state[x]);  writeln('');
       writeln('     age           : ', data^^.age);
       writeln('     gender        : ', data^^.gender);
       writeln('     homezip       : ', data^^.homezip);
       writeln('     online status : ', data^^.StateFlags);
end else writeln('ICQAPICall_GetFullOwnerData failed!');
PrintICQownerdetails:=res;
end;

procedure PrintICQIPList;
var x,y     : byte;
    spacers : byte;
    str     : string;
    socka   : TSockAddr;
begin
    writeln('--------------------------------------');
    writeln('    Nickname                 IP');
    writeln('--------------------------------------');
    writeln('');
    if NrOfICQClient <> 0 then begin
    for x:=0 to NrOfICQClient-1 do begin
         write(ICQUserNames[x]);
         spacers := 21-length(ICQUserNames[x]);
         if spacers > 0 then begin
           for y:=0 to spacers do write(' ');
         end;
         socka.Sin_addr.S_Addr :=ICQUserIPList[x];
         str := STRPAS(inet_ntoa(Socka.Sin_Addr));
         writeln(str);
    end;
    end else writeln('    no users connected');
end;

begin

end.